extends Control

onready var scenes = $"Scenes";
onready var timelines = $"Timelines/ScrollContainer/VBoxContainer";
onready var haveSaves = $"CheckBox";

var karmaArray = [
	"130", 
	"129", 
	"Time", 
	"ItIsDay", 
	"Talked_to_White", 
	"Orange_Karma", 
	"Pink_Karma", 
	"Purple_Karma", 
	"Green_Karma", 
	"Black_Karma", 
	"Blue_F_Karma", 
	"Yellow_Karma", 
	"White_Karma", 
	"Gray_Karma", 
	"Red_Karma", 
	"Blue_M_Karma", 
	"Drunk", 
	"Talked_to_Orange", 
	"Talked_to_Yellow", 
	"TwoGirls", 
	"Chosen_Girl", 
	"Chosen_Karma", 
	"TwoGirlNames", 
	"Chosen_Girl_Name", 
	"Timeline_30_Red_Blue_Boys", 
	"Timeline_30_Gray_White_Boys", 
	"Is_Green_Dead", 
	"Dead_Girl", 
	"Dead_Girl_Name", 
]

var scenesArray = [
	"Scene2", 
	"Scene2_1", 
	"Scene2_2", 
	"Scene4", 
	"Scene6", 
	"Scene7", 
	"Scene8", 
	"Scene9", 
	"Scene12", 
]


var timelineArray = [
	["Timeline_16_4", "Scene2_1", "3", "0"], 
	["Test", "Scene8", "2", "5"], 
	["Timeline_139", "Scene9", "2", "5"], 
	["Timeline_120_main", "Panorama", "2", "5"], 
	["Timeline_140_main", "Panorama", "2", "5"], 
	["Timeline_165", "Death_stairs_girl", "2", "5"], 
	["Timeline_1", "Scene8", "2", "5"], 
	["Timeline_2", "Scene7", "2", "5"], 
	["Timeline_3", "Scene2_1", "3", "0"], 
	["Timeline_3_1", "Scene2_1", "3", "0"], 
	["Timeline_4", "Scene2_1", "3", "1"], 
	["Timeline_5", "Scene2", "3", "5"], 
	["Timeline_6", "Scene2_1", "3", "5"], 
	["Timeline_7", "Scene2", "3", "5"], 
	["Timeline_7_1", "Scene2", "3", "5"], 
	["Timeline_8", "Scene12", "3", "5"], 
	["Timeline_9", "Scene9", "3", "5"], 
	["Timeline_Alt_1", "Scene8", "2", "5"], 
	["Timeline_10", "Scene9", "5", "5"], 
	["Timeline_10_2", "Scene9", "3", "5"], 
	["Timeline_11", "Scene2_1", "4", "5"], 
	["Timeline_12", "Scene2_1", "4", "4"], 
	["Timeline_13", "Scene2_1", "4", "4"], 
	["Timeline_14", "Scene2_1", "16", "4"], 
	["Timeline_15", "Scene2_1", "4", "4"], 
	["Timeline_16", "Scene2_1", "5", "4"], 
	["Timeline_17", "Scene2_1", "4", "5"], 
	["Timeline_18", "Scene2_1", "4", "5"], 
	["Timeline_19", "Scene2_1", "4", "5"], 
	["Timeline_20", "Scene2_1", "4", "5"], 
	["Timeline_22", "Scene2_1", "4", "5"], 
	["Timeline_23", "Scene2_1", "5", "3"], 
	["Timeline_24", "Scene2_1", "5", "3"], 
	["Timeline_25", "Scene2_1", "5", "3"], 
	["Timeline_26", "Scene2_1", "3", "0"], 
	["Timeline_27", "Scene6", "16", "5"], 
	["Timeline_28", "Scene7", "16", "5"], 
	["Timeline_29", "Scene7", "10", "5"], 
	["Timeline_30", "Scene2_1", "4", "5"], 
	["Timeline_31", "Scene2_1", "15", "5"], 
	["Timeline_32", "Scene2_1", "15", "5"], 
	["Timeline_33", "Scene2_1", "14", "5"], 
	["Timeline_35", "Scene2", "10", "5"], 
	["Timeline_36", "Scene2", "2", "5"], 
	["Timeline_38", "Scene2_1", "4", "0"], 
	["Timeline_39", "Scene2_1", "4", "5"], 
	["Timeline_40", "Scene2_1", "4", "3"], 
	["Timeline_41", "Scene2_1", "4", "3"], 
	["Timeline_42", "Scene2_1", "4", "3"], 
	["Timeline_43", "Scene2_1", "4", "5"], 
	["Timeline_44", "Scene2_1", "4", "5"], 
	["Timeline_Sofa", "Scene2_1", "3", "5"], 
	["Timeline_Pink", "Scene2_1", "4", "4"], 
	["Timeline_Black", "Scene2_1", "8", "4"], 
	["Timeline_Green", "Scene2_1", "16", "4"], 
	["Timeline_Purple", "Scene2_1", "16", "4"], 
	["Timeline_Blue", "Scene2_1", "5", "4"],
	["Timeline_dlc_pink", "AmandaDLC", "5", "4"]
]

func _ready():
	$Label.text = tr("text604.2");
	
	
	haveSaves.pressed = SettingsSingleton.GetHaveSave();
	
	Dialogic.load("debug")
	
	Dialogic.set_variable("DialogIndex", "0")
	Dialogic.set_variable("TwinsNPC", "fish")
	Dialogic.set_variable("numberOfActions", "5")
	Dialogic.set_variable("CurrentLabel", "a1")
	Dialogic.set_variable("Footprint", "1")
	Dialogic.set_variable("Knife", "1")
	Dialogic.set_variable("choice1", "0")
	Dialogic.set_variable("choice2", "0")
	Dialogic.set_variable("choice3", "0")
	Dialogic.set_variable("choice4", "0")
	Dialogic.set_variable("choice5", "0")
	Dialogic.set_variable("Dead_Girl", "Green_Karma")
	
	Dialogic.set_variable("Killer", "Pink")
	
	LoadKarmas();
	
	LoadScenes();
	
	LoadTimeLines();
	
	
	

func LoadKarmas():
	var DialogicVarControl = load("res://resources/customControls/DialogicVarControl.tscn");
	
	var karmaIndex = 0;
	for i in karmaArray:
		var panel = DialogicVarControl.instance();
		panel.Init(i);
		panel.Place(karmaIndex);
		$Karma.add_child(panel);
		karmaIndex += 1;

func _on_Button_pressed():
	for i in $"Karma".get_children():
		i.SaveVariable();
	
	Dialogic.save("debug")
	
func LoadScenes():
	return ;
	var buttonsIndex = 0;
	for i in scenesArray:
		var button = Button.new();
		button.text = i;
		button.rect_scale = Vector2(2, 2);
		button.rect_position = Vector2(300, 40 + buttonsIndex * 40);
		buttonsIndex += 1;
		button.connect("pressed", self, "openScene", [i]);
		scenes.add_child(button);
		
func openScene(sceneName):
	get_tree().change_scene("res://scenes/BackgroundScenes/" + sceneName + ".tscn")
	

func LoadTimeLines():
	var buttonsIndex = 0;
	
	var font = DynamicFont.new();
	font.font_data = load("res://resources/fonts/TimesNewerRoman-Regular.otf");
	font.size = 30;
	
	for i in timelineArray:
		var button = Button.new();
		button.text = i[0];
		button.rect_scale = Vector2(2, 2);
		button.rect_position = Vector2(700, 40 + buttonsIndex * 40);
		button.set("custom_fonts/font", font);
		buttonsIndex += 1;
		button.connect("pressed", self, "openTimeline", [i]);
		timelines.add_child(button);

func openTimeline(timelineName):
	
	Dialogic.set_variable("SaveSlotName", "debug")
	Dialogic.save("debug")
	Dialogic.set_variable("NeedCharacter", 1)
	
	Dialogic.set_variable("TimelineSave", timelineName[0])
	Dialogic.set_variable("CurrentBackground", timelineName[1])
	Dialogic.set_variable("CurrentBGM", timelineName[2])
	Dialogic.set_variable("cameraPosition", timelineName[3])
	
	if not SceneLoader.is_connected("on_scene_loaded", self, "MenuLoaded"):
		SceneLoader.connect("on_scene_loaded", self, "MenuLoaded");
	SceneLoader.load_scene("res://scenes/Game.tscn")


func _on_CheckBox_pressed():
	SettingsSingleton.SetHaveSave(haveSaves.pressed);

func _on_CloseButton_pressed():
	if not SceneLoader.is_connected("on_scene_loaded", self, "MenuLoaded"):
		SceneLoader.connect("on_scene_loaded", self, "MenuLoaded");
	SceneLoader.load_scene("res://scenes/MainMenu.tscn")

func MenuLoaded(obj):
	if obj.path == "res://scenes/MainMenu.tscn" or obj.path == "res://scenes/Game.tscn":
		if obj.instance != null:
			get_tree().root.add_child(obj.instance);
			
			for i in get_tree().root.get_children():
				if i.name == "Debug":
					get_tree().root.remove_child(i);
					break;
	
	SceneLoader.disconnect("on_scene_loaded", self, "MenuLoaded");

func _input(ev):
	if ev is InputEventKey and ev.scancode == KEY_ESCAPE and ev.pressed == false:
		_on_CloseButton_pressed();
