extends Node

var languages = [
	{"name":"English", "locale":"en"}, 
	{"name":"Русский", "locale":"ru"}, 
	
]

func GetLanguages():
	return languages;

func SetLanguages(languageLocale):
	SettingsSingleton.SetCurrentLanguage(languageLocale);

func GetLanguageIndex():
	var locale = SettingsSingleton.GetCurrentLanguage();
	for i in languages.size():
		if languages[i].locale == locale:
			return i;
	return 0;


var voiceOverLanguages = [
	{"name":"English", "locale":"en"}, 
	{"name":"Русский", "locale":"ru"}, 
	{"name":"None", "locale":"none"}, 
]

func GetVoiceLanguages():
	return voiceOverLanguages;

func GetVoiceLanguageIndex():
	var locale = SettingsSingleton.GetVoiceoverLanguage();
	for i in voiceOverLanguages.size():
		if voiceOverLanguages[i].locale == locale:
			return i;
	return 1;


var localization = {
	"ReturnToGameButton":"ui_back_to_game", 
	"BackToMenuButton":"ui_back_to_menu", 
	"ApplyButton":"ui_apply", 
	"AllSettingsView/VideoButton":"ui_video", 
	"AllSettingsView/AudioButton":"ui_audio", 
	"AllSettingsView/TextButton":"ui_text", 
	"AllSettingsView/LanguageButton":"ui_text_language", 
	"AllSettingsView/TwitchButton":"ui_twitch", 
	"VideoSettingsView/WindowStates/WindowedCheck":"ui_windowed", 
	"VideoSettingsView/WindowStates/BorderlessCheck":"ui_borderless", 
	"VideoSettingsView/WindowStates/FullscreenCheck":"ui_fullscreen", 
	"VideoSettingsView/WindowResolutionLabel":"ui_resolution", 
	"VideoSettingsView/LowProcessor":"ui_low_processor", 
	"VideoSettingsView/SyncBackground":"ui_sync_background", 
	"VideoSettingsView/ScalingMessage":"ui_scale_error_message", 
	"AudioSettingsView/GeneralVolumeSlider":"ui_general_volume", 
	"AudioSettingsView/MusicVolumeSlider":"ui_music_volume", 
	"AudioSettingsView/DialogueVolumeSlider":"ui_dialogue_volume", 
	"AudioSettingsView/EffectsVolumeSlider":"ui_effects_volume", 
	"TextSettingsView/AutoReadCheck":"ui_autoread", 
	"TextSettingsView/SkipSeenCheck":"ui_skipseen", 
	"TextSettingsView/TextSpeedSlider":"ui_text_speed", 
	"TextSettingsView/ThemeCheck":"ui_text_themecheck", 
	"TextSettingsView/CustomTheme/Text/TextColor":"ui_text_color", 
	"TextSettingsView/CustomTheme/Back/Background":"ui_text_background", 
	"TextSettingsView/CustomTheme/Example/Label":"ui_text_sample", 
	"LanguageSettingsView/InterfaceAndTextLabel":"ui_lang_interface_text", 
	"LanguageSettingsView/VoiceLanguageLabel":"ui_lang_voiceover", 
	"LanguageSettingsView/Voiceover/VBoxContainer/None":"ui_lang_voiceover_none", 
	"TwitchSettingsView/TwitchCheck":"ui_twitch_enable", 
	"TwitchSettingsView/ChannelLabel":"ui_twitch_channel", 
	"TwitchSettingsView/TwitchStatus":"ui_twitch_conn_tool", 
	"TwitchSettingsView/StatusContainer/CheckConnectionButton":"ui_twitch_check_connection", 
	"TwitchSettingsView/TimerSlider":"ui_twitch_time", 
};

func GetLocalization():
	return localization;


var mainMenu = [
	"ui_continue", 
	"ui_new_game", 
	"ui_options", 
	"ui_credits", 
	"ui_gallery", 
	"ui_exit", 
];

func GetMainMenuButtons():
	return mainMenu;


var altTimeline17 = [
	"ui_name_green", 
	"ui_name_black", 
	"ui_name_purple", 
	"ui_name_blue_f", 
	"ui_name_pink", 
	"ui_date_deny"
];

func GetAlternativeTimeline17():
	return altTimeline17;


var slotMenu = [
	"ui_slot_auto_normal", 
	"ui_slot_auto_casual", 
];

func GetSlotMenuButtons():
	return slotMenu;


var mapLocalization = {
	"Map/Inside/Places/Gl-Rest/Label":"ui_map_dining_hall", 
	"Map/Inside/Places/Exit/Label":"ui_map_exit", 
	"Map/Inside/Places/Garage/Label":"ui_map_garage", 
	"Map/Inside/Places/Kitchen/Label":"ui_map_kitchen", 
	"Map/Inside/Places/OfficeH/Label":"ui_map_office", 
	"Map/Inside/Places/Basement/Label":"ui_map_basement", 
	"Map/Inside/Places/Room1/Label":"ui_map_room_1", 
	"Map/Inside/Places/Room2/Label":"ui_map_room_2", 
	"Map/Inside/Places/Room3/Label":"ui_map_room_3", 
	"Map/Inside/Places/Room4/Label":"ui_map_room_4", 
	"Map/Inside/Places/Room5/Label":"ui_map_room_5", 
	"Map/Inside/Places/Smoking/Label":"ui_map_smoking", 
	"Map/Inside/Places/Second":"ui_map_second_floor", 
	"Map/Inside/Places/Third":"ui_map_third_floor", 
};

func GetMapLocalization():
	return mapLocalization;


var girlNames = {
	"Pink_Karma":"ui_name_pink", 
	"Purple_Karma":"ui_name_purple", 
	"Green_Karma":"ui_name_green", 
	"Black_Karma":"ui_name_black", 
	"Blue_F_Karma":"ui_name_blue_f"
};

func GetGirlNames():
	return girlNames;


var boysNames = {
	"White_Karma":"ui_name_white", 
	"Gray_Karma":"ui_name_gray", 
	"Red_Karma":"ui_name_red", 
	"Blue_M_Karma":"ui_name_blue_m", 
};

func GetBoysNames():
	return boysNames;


var karmaMenu = [
	"ui_name_yellow", 
	"ui_name_orange", 
	"ui_name_pink", 
	"ui_name_green", 
	"ui_name_purple", 
	"ui_name_black", 
	"ui_name_blue_f", 
	"ui_name_red", 
	"ui_name_white", 
	"ui_name_blue_m", 
	"ui_name_gray"
];

func GetKarmaButtonNames():
	return karmaMenu;


var charNames = {
	"Pink":"ui_name_pink", 
	"Purple":"ui_name_purple", 
	"Green":"ui_name_green", 
	"Black":"ui_name_black", 
	"Blue_F":"ui_name_blue_f", 
	"White":"ui_name_white", 
	"Gray":"ui_name_gray", 
	"Red":"ui_name_red", 
	"Blue_M":"ui_name_blue_m", 
	"Yellow":"ui_name_yellow"
}

func GetCharNames():
	return charNames;


var dialogicNames = {
	"Линда":"ui_name_black", 
	"Эмилия":"ui_name_blue_f", 
	"Агата":"ui_name_green", 
	"Рената":"ui_name_orange", 
	"Аманда":"ui_name_pink", 
	"Дана":"ui_name_purple", 
	"Сестра":"ui_name_sister", 
	"Дженни":"ui_name_jenny", 
	"Эльза":"ui_name_elsa", 
	
	"Мартин":"ui_name_blue_m", 
	"Роберт":"ui_name_gray", 
	"Хью":"ui_name_mc", 
	"Александр":"ui_name_red", 
	"Джастин":"ui_name_white", 
	"Генри":"ui_name_yellow", 
	"Старик":"ui_name_oldman", 
	"Следователь":"ui_name_interrogator", 
};

func GetDialogicNames():
	return dialogicNames;

var gameEndings = {
	"Timeline_Alt_1":"ui_game_end_question", 
	"Timeline_epilogue":"ui_game_end_victory", 
	"Timeline_29":"ui_game_end_stabbed", 
	"Timeline_36":"ui_game_end_crashed", 
	"Timeline_132":"ui_game_end_electrocuted", 
	"Timeline_139":"ui_game_end_burned", 
	"Timeline_peremoga":"ui_game_end_burned", 
	"Timeline_154":"ui_game_end_poisoned", 
	"Timeline_157_death":"ui_game_end_drowned", 
	"Timeline_157_happyend":"ui_game_end_survived", 
	"Timeline_157_happyend_rw":"ui_game_end_survived", 
	"Timeline_164":"ui_game_end_broken_neck", 
	"Timeline_167":"ui_game_end_shot_down", 
	"Timeline_157_pink_1":"ui_game_end_survived", 
	"Timeline_167w":"ui_game_end_shot_down", 
	"Timeline_173":"ui_game_end_shot_down", 
	"Timeline_173w":"ui_game_end_shot_down", 
	"Timeline_174":"ui_game_end_shot_down", 
	"Timeline_174w":"ui_game_end_shot_down", 
	"Timeline_178":"ui_game_end_strangled", 
	"Timeline_180":"ui_game_end_strangled", 
	"Timeline_185_1":"ui_game_end_shot_down", 
	"Timeline_186_1":"ui_game_end_shot_down", 
	"Timeline_185_2":"ui_game_end_shot_down", 
	"Timeline_186_2":"ui_game_end_shot_down", 
	"Timeline_EasterZakviel":"ui_game_end_rock", 
	"Timeline_172":"ui_game_end_survived"
};

func GetGameEndings():
	return gameEndings;
